package LATMOS::Accounts::Web::Controller::Json::AccAgeContrat;
use Moose;
use namespace::autoclean;

BEGIN { extends 'Catalyst::Controller'; }

=head1 NAME

LATMOS::Accounts::Web::Controller::Json::Expire - Catalyst Controller

=head1 DESCRIPTION

Catalyst Controller.

=head1 METHODS

=cut


=head2 index

=cut

sub index :Path :Args(0) {
    my ( $self, $c ) = @_;

    my $base = $c->model('Accounts')->db;

    my $graph = {
        data => [],
        series => [],
    };

    my %exists = map { $_ => 1 } $base->search_objects('user', 'active=1');
    my %create = $base->attributes_summary_by_object('user', 'create');
    my %contrat = $base->attributes_summary_by_object('user', 'contratType');
    my @contrat = $base->search_objects('group', 'sutype=contrattype');
    
    my %dates;
    foreach my $user (keys %create) {
        $exists{$user} or next;
        foreach my $date (@{ $create{$user} }) {
            $date or next;
            $date =~ s/-.*//;
            my $status = $contrat{$user}[0] or next;

            $dates{$_}{$date} ||= 0 foreach(@contrat);
            $dates{$status}{$date} ++;
        }
    }

    foreach my $status (@contrat) {
        push(@{ $graph->{data} }, [ map { [ $_, $dates{$status}{$_} +0 ] } sort { $a cmp $b } keys %{ $dates{$status} } ]);
        push(@{ $graph->{series} }, { label => $status });
    } 
    
    $c->stash->{data} = $graph;
}



=encoding utf8

=head1 AUTHOR

Olivier Thauvin,Guyancourt - B1428,+33 1 80285052,

=head1 LICENSE

This library is free software. You can redistribute it and/or modify
it under the same terms as Perl itself.

=cut

__PACKAGE__->meta->make_immutable;

1;
